Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj	(revision 3011)
@@ -87,5 +87,7 @@
   <ItemGroup>
     <Compile Include="BaseDao.cs" />
+    <Compile Include="ClientConfigDao.cs" />
     <Compile Include="ClientDao.cs" />
+    <Compile Include="ClientGroupDao.cs" />
     <Compile Include="ContextFactory.cs" />
     <Compile Include="Hive.designer.cs">
@@ -94,8 +96,7 @@
       <DependentUpon>Hive.dbml</DependentUpon>
     </Compile>
-    <Compile Include="IClientDao.cs" />
-    <Compile Include="IGenericDao.cs" />
-    <Compile Include="IJobDao.cs" />
+    <Compile Include="JobDao.cs" />
     <Compile Include="LINQDataAccessPlugin.cs" />
+    <Compile Include="PluginInfoDao.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
@@ -122,4 +123,8 @@
       <Project>{134F93D7-E7C8-4ECD-9923-7F63259A60D8}</Project>
       <Name>HeuristicLab.Hive.Contracts-3.2</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.Server.DataAccess\3.2\HeuristicLab.Hive.Server.DataAccess-3.2.csproj">
+      <Project>{4D5A2A16-66C2-431D-9AA3-BD3041E64B84}</Project>
+      <Name>HeuristicLab.Hive.Server.DataAccess-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml	(revision 3011)
@@ -51,5 +51,5 @@
       <Column Name="ResourceId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="true" />
       <Column Name="Percentage" Type="System.Double" DbType="Float" CanBeNull="true" />
-      <Column Name="SerializedJob" Type="System.Data.Linq.Binary" DbType="VarBinary(MAX)" CanBeNull="true" UpdateCheck="Never" />
+      <Column Name="SerializedJob" Type="System.Data.Linq.Binary" DbType="VarBinary(MAX)" CanBeNull="true" UpdateCheck="Never" IsDelayLoaded="true" />
       <Column Name="DateCreated" Type="System.DateTime" DbType="DateTime" CanBeNull="true" />
       <Column Name="DateCalculated" Type="System.DateTime" DbType="DateTime" CanBeNull="true" />
@@ -58,6 +58,6 @@
       <Column Name="ProjectId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="true" />
       <Column Name="UserId" Type="System.Guid" DbType="UniqueIdentifier" CanBeNull="true" />
-      <Column Name="CoresNeeded" Type="System.Int32" DbType="Int" CanBeNull="true" />
-      <Column Name="MemoryNeeded" Type="System.Int32" DbType="Int" CanBeNull="true" />
+      <Column Name="CoresNeeded" Type="System.Int32" DbType="Int" CanBeNull="false" />
+      <Column Name="MemoryNeeded" Type="System.Int32" DbType="Int" CanBeNull="false" />
       <Association Name="Job_AssignedResource" Member="AssignedResources" ThisKey="JobId" OtherKey="JobId" Type="AssignedResource" />
       <Association Name="Job_Job" Member="Jobs" ThisKey="JobId" OtherKey="ParentJobId" Type="Job" />
@@ -88,5 +88,5 @@
       <Column Name="JobId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" CanBeNull="false" />
       <Column Name="PluginId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" CanBeNull="false" />
-      <Column Name="RequiredPluginId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
+      <Column Name="RequiredPluginId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" UpdateCheck="Never" />
       <Association Name="Job_RequiredPlugin" Member="Job" ThisKey="JobId" OtherKey="JobId" Type="Job" IsForeignKey="true" />
       <Association Name="PluginInfo_RequiredPlugin" Member="PluginInfo" ThisKey="PluginId" OtherKey="PluginId" Type="PluginInfo" IsForeignKey="true" DeleteRule="CASCADE" DeleteOnNull="true" />
@@ -95,5 +95,5 @@
   <Table Name="dbo.Resource" Member="Resources">
     <Type Name="Resource">
-      <Column Name="ResourceId" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" IsDbGenerated="true" CanBeNull="false" />
+      <Column Name="ResourceId" AutoSync="OnInsert" Type="System.Guid" DbType="UniqueIdentifier NOT NULL" IsPrimaryKey="true" CanBeNull="false" />
       <Column Name="Name" Type="System.String" DbType="VarChar(MAX)" CanBeNull="true" />
       <Association Name="Resource_AssignedResource" Member="AssignedResources" ThisKey="ResourceId" OtherKey="ResourceId" Type="AssignedResource" />
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.dbml.layout	(revision 3011)
@@ -132,5 +132,5 @@
       </nestedChildShapes>
     </classShape>
-    <associationConnector edgePoints="[(3.625 : 9.70755126953125); (2.75 : 9.70755126953125)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(3.625 : 9.70755126953125); (2.75 : 9.70755126953125)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Client/Client_UptimeStatistic" />
       <nodes>
@@ -139,5 +139,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(5.625 : 8.78770182291667); (9 : 8.78770182291667)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(5.625 : 8.78770182291667); (9 : 8.78770182291667)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Client/Client_Job" />
       <nodes>
@@ -146,5 +146,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(4.5 : 6.94399251302083); (4.5 : 7.625)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(4.5 : 6.94399251302083); (4.5 : 7.625)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/Resource/Resource_Client" />
       <nodes>
@@ -153,5 +153,5 @@
       </nodes>
     </associationConnector>
-    <associationConnector edgePoints="[(4.625 : 11); (4.625 : 10.1651025390625)]" fixedFrom="Algorithm" fixedTo="Algorithm">
+    <associationConnector edgePoints="[(4.625 : 11); (4.625 : 10.1651025390625)]" fixedFrom="NotFixed" fixedTo="NotFixed">
       <AssociationMoniker Name="/HiveDataContext/ClientConfig/ClientConfig_Client" />
       <nodes>
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.designer.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/Hive.designer.cs	(revision 3011)
@@ -604,5 +604,5 @@
 		}
 		
-		[Column(Storage="_UpDownTimeCalendar", DbType="Xml", UpdateCheck=UpdateCheck.Never)]
+		[Column(Storage="_UpDownTimeCalendar", DbType="Xml", CanBeNull=true, UpdateCheck=UpdateCheck.Never)]
 		public System.Xml.Linq.XElement UpDownTimeCalendar
 		{
@@ -1029,5 +1029,5 @@
 		private System.Nullable<double> _Percentage;
 		
-		private System.Data.Linq.Binary _SerializedJob;
+		private System.Data.Linq.Link<System.Data.Linq.Binary> _SerializedJob;
 		
 		private System.Nullable<System.DateTime> _DateCreated;
@@ -1043,7 +1043,7 @@
 		private System.Nullable<System.Guid> _UserId;
 		
-		private System.Nullable<int> _CoresNeeded;
-		
-		private System.Nullable<int> _MemoryNeeded;
+		private int _CoresNeeded;
+		
+		private int _MemoryNeeded;
 		
 		private EntitySet<AssignedResource> _AssignedResources;
@@ -1087,7 +1087,7 @@
     partial void OnUserIdChanging(System.Nullable<System.Guid> value);
     partial void OnUserIdChanged();
-    partial void OnCoresNeededChanging(System.Nullable<int> value);
+    partial void OnCoresNeededChanging(int value);
     partial void OnCoresNeededChanged();
-    partial void OnMemoryNeededChanging(System.Nullable<int> value);
+    partial void OnMemoryNeededChanging(int value);
     partial void OnMemoryNeededChanged();
     #endregion
@@ -1212,18 +1212,18 @@
 		}
 		
-		[Column(Storage="_SerializedJob", DbType="VarBinary(MAX)", UpdateCheck=UpdateCheck.Never)]
+		[Column(Storage="_SerializedJob", DbType="VarBinary(MAX)", CanBeNull=true, UpdateCheck=UpdateCheck.Never)]
 		public System.Data.Linq.Binary SerializedJob
 		{
 			get
 			{
-				return this._SerializedJob;
-			}
-			set
-			{
-				if ((this._SerializedJob != value))
+				return this._SerializedJob.Value;
+			}
+			set
+			{
+				if ((this._SerializedJob.Value != value))
 				{
 					this.OnSerializedJobChanging(value);
 					this.SendPropertyChanging();
-					this._SerializedJob = value;
+					this._SerializedJob.Value = value;
 					this.SendPropertyChanged("SerializedJob");
 					this.OnSerializedJobChanged();
@@ -1357,5 +1357,5 @@
 		
 		[Column(Storage="_CoresNeeded", DbType="Int")]
-		public System.Nullable<int> CoresNeeded
+		public int CoresNeeded
 		{
 			get
@@ -1377,5 +1377,5 @@
 		
 		[Column(Storage="_MemoryNeeded", DbType="Int")]
-		public System.Nullable<int> MemoryNeeded
+		public int MemoryNeeded
 		{
 			get
@@ -1953,5 +1953,5 @@
 		}
 		
-		[Column(Storage="_RequiredPluginId", AutoSync=AutoSync.OnInsert, DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true, IsDbGenerated=true)]
+		[Column(Storage="_RequiredPluginId", AutoSync=AutoSync.OnInsert, DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true, IsDbGenerated=true, UpdateCheck=UpdateCheck.Never)]
 		public System.Guid RequiredPluginId
 		{
@@ -2099,5 +2099,5 @@
 		}
 		
-		[Column(Storage="_ResourceId", AutoSync=AutoSync.OnInsert, DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true, IsDbGenerated=true)]
+		[Column(Storage="_ResourceId", AutoSync=AutoSync.OnInsert, DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
 		public System.Guid ResourceId
 		{
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/JobDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/JobDao.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/JobDao.cs	(revision 3011)
@@ -0,0 +1,166 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Data.Linq;
+using HeuristicLab.Hive.Server.DataAccess;
+using System.IO;
+using System.Data.SqlClient;
+
+namespace HeuristicLab.Hive.Server.LINQDataAccess {
+  public class JobDao: BaseDao<JobDto, Job>, IJobDao {
+   
+    #region IGenericDao<JobDto,Job> Members
+
+    public JobDto FindById(Guid id) {
+      return (from job in Context.Jobs
+              where job.JobId.Equals(id)
+              select EntityToDto(job, null)).SingleOrDefault();
+    }
+
+    public IEnumerable<JobDto> FindAll() {
+      return (from job in Context.Jobs
+              select EntityToDto(job, null)).ToList();
+    }
+
+    public byte[] GetBinaryJobFile(Guid jobId) {
+      return (from job in Context.Jobs
+              where job.JobId.Equals(jobId)
+              select job.SerializedJob).SingleOrDefault().ToArray();
+    }
+
+    public JobDto Insert(JobDto bObj) {
+      Job j = DtoToEntity(bObj, null);
+      Context.Jobs.InsertOnSubmit(j);
+      Context.SubmitChanges();
+      bObj.Id = j.JobId;
+      return bObj;
+    }
+
+    public SerializedJob InsertWithAttachedJob(SerializedJob job) {
+      Job j = DtoToEntity(job.JobInfo, null);
+      j.SerializedJob = job.SerializedJobData;
+      Context.Jobs.InsertOnSubmit(j);
+      Context.SubmitChanges();
+      job.JobInfo.Id = j.JobId;
+      return job;
+
+    }
+
+    public void Delete(JobDto bObj) {
+      Job job = Context.Jobs.SingleOrDefault(j => j.JobId.Equals(bObj.Id));
+      Context.Jobs.DeleteOnSubmit(job);
+      Context.SubmitChanges();
+    }
+
+    public void Update(JobDto bObj) {
+      Job job = Context.Jobs.SingleOrDefault(j => j.JobId.Equals(bObj.Id));
+      DtoToEntity(bObj, job);
+      Context.SubmitChanges();
+    }
+
+    public IEnumerable<JobDto> FindActiveJobsOfClient(ClientDto client) {
+      return (from j in Context.Jobs
+              where (j.JobState == Enum.GetName(typeof (State), State.calculating) ||
+                     j.JobState == Enum.GetName(typeof (State), State.abort) ||
+                     j.JobState == Enum.GetName(typeof (State), State.requestSnapshot) ||
+                     j.JobState == Enum.GetName(typeof (State), State.requestSnapshotSent)) &&
+                    (j.ResourceId.Equals(client.Id))
+              select EntityToDto(j, null)).ToList();
+    }
+    public IEnumerable<JobDto> FindFittingJobsForClient(State state, int freeCores, int freeMemory) {
+      return (from j in Context.Jobs
+              where j.JobState == Enum.GetName(typeof (State), State.offline) &&
+                    j.CoresNeeded <= freeCores &&
+                    j.MemoryNeeded <= freeMemory
+              select EntityToDto(j, null)).ToList();
+      
+    }
+
+    public IEnumerable<JobDto> GetJobsByState(State state) {
+      return (from j in Context.Jobs
+              where (j.JobState == Enum.GetName(typeof (State), state))
+              select EntityToDto(j, null)).ToList();
+    }
+
+    public void AssignClientToJob(Guid clientId, Guid jobId) {
+      Client c = Context.Clients.SingleOrDefault(client => client.ResourceId.Equals(clientId));
+      Job j = Context.Jobs.SingleOrDefault(job => job.JobId.Equals(jobId));
+      c.Jobs.Add(j);
+      j.Client = c;
+      Context.SubmitChanges();      
+    }
+
+    public void SetJobOffline(JobDto job) {
+      Job j = Context.Jobs.SingleOrDefault(jq => jq.JobId.Equals(job.Id));
+      j.Client = null;
+      j.JobState = Enum.GetName(typeof(State), State.offline); 
+      Context.SubmitChanges();
+    }
+
+    public Stream GetSerializedJobStream(Guid jobId) {
+      HiveDataContext hdc = new HiveDataContext();
+      hdc.Transaction = null;
+
+      VarBinarySource source =
+        new VarBinarySource(
+          hdc.Connection as SqlConnection, null,
+          "Job", "SerializedJob", "JobId", jobId);
+
+      return new VarBinaryStream(source);
+    }
+
+    #endregion
+
+    public override Job DtoToEntity(JobDto source, Job target) {
+      if (source == null)
+        return null;
+      if (target == null)
+        target = new Job();
+
+      target.CoresNeeded = source.CoresNeeded;
+      target.MemoryNeeded = source.MemoryNeeded;
+
+      target.DateCalculated = source.DateCalculated;
+      target.DateCreated = source.DateCreated;
+      target.JobId = source.Id;
+
+      target.Percentage = source.Percentage;
+
+      target.Priority = source.Priority;
+      target.JobState = Enum.GetName(typeof(State), source.State);
+      return target;
+    }
+
+    //Assigned ressources are not used atm!
+    //Client is not used ATM - not sure when we stopped using those...
+    public override JobDto EntityToDto(Job source, JobDto target) {
+      if (source == null)
+        return null;
+      if(target == null)
+        target = new JobDto();
+    
+      //target.ParentJob = null;
+      //target.PluginsNeeded = null;
+      //target.Client = null;
+      //target.Project = null;
+      
+      target.CoresNeeded = source.CoresNeeded;
+      target.MemoryNeeded = source.MemoryNeeded;
+
+
+
+      target.DateCalculated = source.DateCalculated;
+      target.DateCreated = source.DateCreated;
+      target.Id = source.JobId;
+      
+          
+      target.Percentage = source.Percentage;
+      
+      target.Priority = source.Priority;
+      target.State = (State) Enum.Parse(typeof (State), source.JobState);
+      return target;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/LINQDataAccessPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/LINQDataAccessPlugin.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/LINQDataAccessPlugin.cs	(revision 3011)
@@ -9,4 +9,6 @@
   [PluginFile("HeuristicLab.Hive.Server.LINQDataAccess-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Server.DataAccess-3.2")]
   public class LINQDataAccessPlugin: PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/PluginInfoDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/PluginInfoDao.cs	(revision 3011)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/PluginInfoDao.cs	(revision 3011)
@@ -0,0 +1,96 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using HeuristicLab.Hive.Server.DataAccess;
+
+namespace HeuristicLab.Hive.Server.LINQDataAccess {
+  public class PluginInfoDao: BaseDao<HivePluginInfoDto, PluginInfo>, IPluginInfoDao {
+    #region IGenericDao<HivePluginInfoDto,PluginInfo> Members
+
+    public HivePluginInfoDto FindById(Guid id) {
+      return (from pi in Context.PluginInfos
+              where pi.PluginId.Equals(id)
+              select EntityToDto(pi, null)
+             ).SingleOrDefault();  
+    }
+
+    public IEnumerable<HivePluginInfoDto> FindAll() {
+      return (from pi in Context.PluginInfos              
+              select EntityToDto(pi, null)
+       ).ToList();  
+    }
+
+    public HivePluginInfoDto Insert(HivePluginInfoDto bObj) {
+      PluginInfo pi = DtoToEntity(bObj, null);
+      Context.PluginInfos.InsertOnSubmit(pi);
+      Context.SubmitChanges();
+      bObj.Id = pi.PluginId;
+      return bObj;
+    }
+
+    public void Delete(HivePluginInfoDto bObj) {
+      PluginInfo pi = Context.PluginInfos.SingleOrDefault(p => p.PluginId.Equals(bObj.Id));
+      Context.PluginInfos.DeleteOnSubmit(pi);      
+    }
+
+    public void Update(HivePluginInfoDto bObj) {
+      PluginInfo pi = Context.PluginInfos.SingleOrDefault(p => p.PluginId.Equals(bObj.Id));
+      DtoToEntity(bObj, pi);
+      Context.SubmitChanges();
+    }
+
+    public void InsertPluginDependenciesForJob(JobDto jobDto) {
+      foreach (HivePluginInfoDto info in jobDto.PluginsNeeded) {        
+        PluginInfo dbpi =
+          Context.PluginInfos.Where(pi => pi.Name.Equals(info.Name) && pi.Version == info.Version).SingleOrDefault();
+        if (dbpi == null) {
+          dbpi = new PluginInfo {
+                                  BuildDate = info.BuildDate.ToString(),
+                                  Name = info.Name,
+                                  Version = info.Version
+                                };
+          Context.PluginInfos.InsertOnSubmit(dbpi);
+          Context.SubmitChanges();
+        }
+
+        RequiredPlugin rq = new RequiredPlugin();
+        rq.JobId = jobDto.Id;
+        rq.PluginInfo = dbpi;
+        Context.RequiredPlugins.InsertOnSubmit(rq);
+        Context.SubmitChanges();
+      }
+    }
+
+    #endregion
+
+    // Build Date not mapped - won't matter anyway, it's a obsolete field.
+    public override PluginInfo DtoToEntity(HivePluginInfoDto source, PluginInfo target) {
+      if (source == null)
+        return null;
+      if (target == null)
+        target = new PluginInfo();
+
+      target.Name = source.Name;
+      target.PluginId = source.Id;
+      target.Version = source.Version;      
+
+      return target;
+
+    }
+
+    public override HivePluginInfoDto EntityToDto(PluginInfo source, HivePluginInfoDto target) {
+      if (source == null)
+        return null;
+      if (target == null)
+        target = new HivePluginInfoDto();
+
+      target.Name = source.Name;
+      target.Id = source.PluginId;
+      target.Version = source.Version;
+
+      return target;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Hive.Server.Scheduler/3.2/HeuristicLab.Hive.Server.Scheduler-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Scheduler/3.2/HeuristicLab.Hive.Server.Scheduler-3.2.csproj	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server.Scheduler/3.2/HeuristicLab.Hive.Server.Scheduler-3.2.csproj	(revision 3011)
@@ -80,5 +80,4 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="DefaultScheduler.cs" />
     <Compile Include="HiveServerSchedulerPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
Index: /trunk/sources/HeuristicLab.Hive.Server/3.2/HeuristicLab.Hive.Server-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server/3.2/HeuristicLab.Hive.Server-3.2.csproj	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server/3.2/HeuristicLab.Hive.Server-3.2.csproj	(revision 3011)
@@ -88,4 +88,7 @@
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
     </Reference>
+    <Reference Include="System.Data.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
     <Reference Include="System.Runtime.Serialization">
       <RequiredTargetFramework>3.0</RequiredTargetFramework>
@@ -94,4 +97,5 @@
       <RequiredTargetFramework>3.0</RequiredTargetFramework>
     </Reference>
+    <Reference Include="System.Transactions" />
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -156,4 +160,8 @@
       <Name>HeuristicLab.Hive.Server.Core-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.Server.LINQDataAccess\3.2\HeuristicLab.Hive.Server.LINQDataAccess-3.2.csproj">
+      <Project>{A4499DDD-D1B8-414F-98F6-903C2C71BEB0}</Project>
+      <Name>HeuristicLab.Hive.Server.LINQDataAccess-3.2</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
Index: /trunk/sources/HeuristicLab.Hive.Server/3.2/HiveServerPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server/3.2/HiveServerPlugin.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server/3.2/HiveServerPlugin.cs	(revision 3011)
@@ -30,6 +30,8 @@
   [PluginFile("HeuristicLab.Hive.Server-3.2.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.DataAccess-3.2")]
   [PluginDependency("HeuristicLab.Hive.Server.Core-3.2")]
   [PluginDependency("HeuristicLab.Hive.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Hive.Server.LINQDataAccess-3.2")]
   [PluginDependency("HeuristicLab.SpringNET", "1.3.0.0")]
   public class HiveServerPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs	(revision 3010)
+++ /trunk/sources/HeuristicLab.Hive.Server/3.2/ServiceCallInterception.cs	(revision 3011)
@@ -5,4 +5,6 @@
 using AopAlliance.Intercept;
 using System.Threading;
+using HeuristicLab.Hive.Server.LINQDataAccess;
+using System.Transactions;
 
 namespace HeuristicLab.Hive.Server {
@@ -12,6 +14,19 @@
     public object Invoke(IMethodInvocation invocation) {
       Console.WriteLine(DateTime.Now + " - " + Thread.CurrentThread.ManagedThreadId + " - Entering Method " + invocation.Method.Name);
-      var obj = invocation.Proceed();
-      Console.WriteLine(DateTime.Now + " - " + Thread.CurrentThread.ManagedThreadId + " - Leaving Method " + invocation.Method.Name);
+
+      Object obj;
+      
+      using (TransactionScope scope = new TransactionScope()) {
+        try {
+          obj = invocation.Proceed();
+          scope.Complete();
+        } finally {
+          ContextFactory.Context.Dispose();
+          Console.WriteLine("setting old context null");
+          ContextFactory.Context = null;
+          Console.WriteLine("Disposing old Context");      
+        }
+      }     
+      Console.WriteLine(DateTime.Now + " - " + Thread.CurrentThread.ManagedThreadId + " - Leaving Method " + invocation.Method.Name);            
       return obj;
     }
